// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{ffi, Context, Image, ScreenshotKind, ScreenshotMediaKind, Video};
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "AsScreenshot")]
    pub struct Screenshot(Object<ffi::AsScreenshot, ffi::AsScreenshotClass>);

    match fn {
        type_ => || ffi::as_screenshot_get_type(),
    }
}

impl Screenshot {
    pub const NONE: Option<&'static Screenshot> = None;

    #[doc(alias = "as_screenshot_new")]
    pub fn new() -> Screenshot {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::as_screenshot_new()) }
    }
}

impl Default for Screenshot {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Screenshot>> Sealed for T {}
}

pub trait ScreenshotExt: IsA<Screenshot> + sealed::Sealed + 'static {
    #[doc(alias = "as_screenshot_add_image")]
    fn add_image(&self, image: &impl IsA<Image>) {
        unsafe {
            ffi::as_screenshot_add_image(
                self.as_ref().to_glib_none().0,
                image.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "as_screenshot_add_video")]
    fn add_video(&self, video: &impl IsA<Video>) {
        unsafe {
            ffi::as_screenshot_add_video(
                self.as_ref().to_glib_none().0,
                video.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "as_screenshot_clear_images")]
    fn clear_images(&self) {
        unsafe {
            ffi::as_screenshot_clear_images(self.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "as_screenshot_get_caption")]
    #[doc(alias = "get_caption")]
    fn caption(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::as_screenshot_get_caption(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_screenshot_get_context")]
    #[doc(alias = "get_context")]
    fn context(&self) -> Option<Context> {
        unsafe {
            from_glib_none(ffi::as_screenshot_get_context(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_screenshot_get_environment")]
    #[doc(alias = "get_environment")]
    fn environment(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::as_screenshot_get_environment(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_screenshot_get_image")]
    #[doc(alias = "get_image")]
    fn image(&self, width: u32, height: u32, scale: u32) -> Option<Image> {
        unsafe {
            from_glib_none(ffi::as_screenshot_get_image(
                self.as_ref().to_glib_none().0,
                width,
                height,
                scale,
            ))
        }
    }

    #[doc(alias = "as_screenshot_get_images")]
    #[doc(alias = "get_images")]
    fn images(&self) -> Vec<Image> {
        unsafe {
            FromGlibPtrContainer::from_glib_none(ffi::as_screenshot_get_images(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_screenshot_get_images_all")]
    #[doc(alias = "get_images_all")]
    fn images_all(&self) -> Vec<Image> {
        unsafe {
            FromGlibPtrContainer::from_glib_none(ffi::as_screenshot_get_images_all(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_screenshot_get_kind")]
    #[doc(alias = "get_kind")]
    fn kind(&self) -> ScreenshotKind {
        unsafe { from_glib(ffi::as_screenshot_get_kind(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_screenshot_get_media_kind")]
    #[doc(alias = "get_media_kind")]
    fn media_kind(&self) -> ScreenshotMediaKind {
        unsafe {
            from_glib(ffi::as_screenshot_get_media_kind(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_screenshot_get_videos")]
    #[doc(alias = "get_videos")]
    fn videos(&self) -> Vec<Video> {
        unsafe {
            FromGlibPtrContainer::from_glib_none(ffi::as_screenshot_get_videos(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_screenshot_get_videos_all")]
    #[doc(alias = "get_videos_all")]
    fn videos_all(&self) -> Vec<Video> {
        unsafe {
            FromGlibPtrContainer::from_glib_none(ffi::as_screenshot_get_videos_all(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_screenshot_is_valid")]
    fn is_valid(&self) -> bool {
        unsafe { from_glib(ffi::as_screenshot_is_valid(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_screenshot_set_caption")]
    fn set_caption(&self, caption: &str, locale: &str) {
        unsafe {
            ffi::as_screenshot_set_caption(
                self.as_ref().to_glib_none().0,
                caption.to_glib_none().0,
                locale.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "as_screenshot_set_context")]
    fn set_context(&self, context: &impl IsA<Context>) {
        unsafe {
            ffi::as_screenshot_set_context(
                self.as_ref().to_glib_none().0,
                context.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "as_screenshot_set_environment")]
    fn set_environment(&self, env_id: Option<&str>) {
        unsafe {
            ffi::as_screenshot_set_environment(
                self.as_ref().to_glib_none().0,
                env_id.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "as_screenshot_set_kind")]
    fn set_kind(&self, kind: ScreenshotKind) {
        unsafe {
            ffi::as_screenshot_set_kind(self.as_ref().to_glib_none().0, kind.into_glib());
        }
    }
}

impl<O: IsA<Screenshot>> ScreenshotExt for O {}
